﻿Imports IrcDotNet
Public Class ChatChannel
    Dim thisname As String = ""
    Dim thistopic As String = ""
    Dim msglog As String = ""
    Dim formattedmsglog As String = ""
    Dim ircchannel As IrcChannel = Nothing
    Dim height As Double = 0
  
    Public Property ChannelName As String
        Get
            Return thisname
        End Get
        Set(value As String)
            thisname = value
        End Set
    End Property
    Public Property ChannelTopic As String
        Get
            Return thistopic
        End Get
        Set(value As String)
            thistopic = value
        End Set
    End Property
    Public Property MessageLog() As String
        Get
            Return msglog
        End Get
        Set(ByVal value As String)
            msglog = value
        End Set
    End Property
    Public Property FormattedMessageLog() As String
        Get
            Return formattedmsglog
        End Get
        Set(ByVal value As String)
            formattedmsglog = value
        End Set
    End Property

    Public Property Channel() As IrcChannel
        Get
            Return ircchannel
        End Get
        Set(ByVal value As IrcChannel)
            If Not IsNothing(ircchannel) Then
                RemoveHandler ircchannel.UsersListReceived, AddressOf ircClient1_Channel_UsersListReceived
                RemoveHandler ircchannel.ModesChanged, AddressOf ircClient1_Channel_ModesChanged
                RemoveHandler ircchannel.TopicChanged, AddressOf ircClient1_Channel_TopicChanged
                RemoveHandler ircchannel.UserJoined, AddressOf ircClient1_Channel_UserJoined
                RemoveHandler ircchannel.UserLeft, AddressOf ircClient1_Channel_UserLeft
                RemoveHandler ircchannel.UserKicked, AddressOf ircClient1_Channel_UserKicked
                RemoveHandler ircchannel.MessageReceived, AddressOf ClientChannel_MessageReceived
                RemoveHandler ircchannel.NoticeReceived, AddressOf ircClient1_Channel_NoticeReceived
            End If
            ircchannel = value
            If Not IsNothing(ircchannel) Then
                AddHandler ircchannel.UsersListReceived, AddressOf ircClient1_Channel_UsersListReceived
                AddHandler ircchannel.ModesChanged, AddressOf ircClient1_Channel_ModesChanged
                AddHandler ircchannel.TopicChanged, AddressOf ircClient1_Channel_TopicChanged
                AddHandler ircchannel.UserJoined, AddressOf ircClient1_Channel_UserJoined
                AddHandler ircchannel.UserLeft, AddressOf ircClient1_Channel_UserLeft
                AddHandler ircchannel.UserKicked, AddressOf ircClient1_Channel_UserKicked
                AddHandler ircchannel.MessageReceived, AddressOf ClientChannel_MessageReceived
                AddHandler ircchannel.NoticeReceived, AddressOf ircClient1_Channel_NoticeReceived

            End If

        End Set
    End Property
    Public Property ChannelHeight As Double
        Get
            Return height
        End Get
        Set(value As Double)
            height = value
        End Set
    End Property
    Public Event ChannelUserListReceived(ByVal sender As Object, ByVal e As System.EventArgs)
    Public Event ChannelModesChanged(ByVal sender As Object, ByVal e As System.EventArgs)
    Public Event ChannelTopicChanged(ByVal sender As Object, ByVal e As System.EventArgs)
    Public Event ChannelUserJoined(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
    Public Event ChannelUserLeft(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
    Public Event ChannelUserKicked(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
    Public Event ChannelMessageReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
    Public Event ChannelNoticeReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)

    Private Sub ircClient1_Channel_UsersListReceived(ByVal sender As Object, ByVal e As System.EventArgs)
        RaiseEvent ChannelUserListReceived(Me, e)
    End Sub
    Private Sub ircClient1_Channel_ModesChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        RaiseEvent ChannelModesChanged(Me, e)
    End Sub
    Private Sub ircClient1_Channel_TopicChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        thistopic = ircchannel.Topic
        RaiseEvent ChannelTopicChanged(Me, e)
    End Sub
    Private Sub ircClient1_Channel_UserJoined(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
        RaiseEvent ChannelUserJoined(Me, e)
    End Sub
    Private Sub ircClient1_Channel_UserLeft(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
        RaiseEvent ChannelUserLeft(Me, e)
    End Sub
    Private Sub ircClient1_Channel_UserKicked(ByVal sender As Object, ByVal e As IrcChannelUserEventArgs)
        RaiseEvent ChannelUserKicked(Me, e)
    End Sub

    Private Sub ClientChannel_MessageReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
        RaiseEvent ChannelMessageReceived(Me, e)
    End Sub
    Private Sub ircClient1_Channel_NoticeReceived(ByVal sender As Object, ByVal e As IrcMessageEventArgs)
        RaiseEvent ChannelNoticeReceived(Me, e)
    End Sub
    Public Sub RemoveHandlers()
        'not sure what the proper thing to do with this object
        'in terms of implementing disposal but seems prudent
        'to remove the handlers at least
        If Not IsNothing(ircchannel) Then
            RemoveHandler ircchannel.UsersListReceived, AddressOf ircClient1_Channel_UsersListReceived
            RemoveHandler ircchannel.ModesChanged, AddressOf ircClient1_Channel_ModesChanged
            RemoveHandler ircchannel.TopicChanged, AddressOf ircClient1_Channel_TopicChanged
            RemoveHandler ircchannel.UserJoined, AddressOf ircClient1_Channel_UserJoined
            RemoveHandler ircchannel.UserLeft, AddressOf ircClient1_Channel_UserLeft
            RemoveHandler ircchannel.UserKicked, AddressOf ircClient1_Channel_UserKicked
            RemoveHandler ircchannel.MessageReceived, AddressOf ClientChannel_MessageReceived
            RemoveHandler ircchannel.NoticeReceived, AddressOf ircClient1_Channel_NoticeReceived
        End If
    End Sub
End Class
