﻿Imports System.Diagnostics
Imports System.Drawing
Imports System.Threading
Imports System.Threading.Tasks
Imports Wisej.Web

Partial Public Class SortBox
    Inherits UserControl
    ' gap between lines.
    Private gap As Integer = 2

    ' line width;
    Private lineWidth As Integer = 2

    ' values to sort.
    Private values As Integer() = New Integer(-1) {}


    ' sorted flag.
    Private sorted As Boolean = False


    Public MainFormLbl As Label
    Public Event SortCompleted As EventHandler

    Private Sub buttonSort_Click(sender As Object, e As EventArgs) Handles buttonSort.Click
        ' reshuffle.
        If Me.sorted Then
            Me.sorted = False
            GenerateLines()
            DrawLines()
        End If

        Select Case Me.SortMode
            Case ChatasaurWiseJTest.SortMode.BubbleSort
                Application.StartTask(Function()
                                          RunBubbleSort()

                                      End Function)
                Exit Select

            Case ChatasaurWiseJTest.SortMode.QuickSort
                Application.StartTask(Function()
                                          RunQuickSort()

                                      End Function)
                Exit Select

            Case ChatasaurWiseJTest.SortMode.SelectionSort
                Application.StartTask(Function()
                                          RunSelectionSort()

                                      End Function)
                Exit Select
        End Select
    End Sub
    Public Sub DoSort()
        ' reshuffle.
        If Me.sorted Then
            Me.sorted = False
            GenerateLines()
            DrawLines()
        End If

        Select Case Me.SortMode
            Case ChatasaurWiseJTest.SortMode.BubbleSort
                Application.StartTask(Function()
                                          RunBubbleSort()

                                      End Function)
                Exit Select

            Case ChatasaurWiseJTest.SortMode.QuickSort
                Application.StartTask(Function()
                                          RunQuickSort()

                                      End Function)
                Exit Select

            Case ChatasaurWiseJTest.SortMode.SelectionSort
                Application.StartTask(Function()
                                          RunSelectionSort()

                                      End Function)
                Exit Select
        End Select
    End Sub


    Private Sub RunSelectionSort()
        Dim stopwatch As New Stopwatch()
        Me.buttonSort.Enabled = False
        Me.buttonSort.Text = "Sorting..."

        Dim i = 0
        Dim max = values.Length - 1
        stopwatch.Start()
        While i <= max - 1
            Dim k = max
            While k >= i + 1
                If values(i) > values(k) Then
                    SwapValue(i, k)
                End If
                k = k - 1
            End While
            i = i + 1

        End While
        stopwatch.[Stop]()

        RaiseEvent SortCompleted(Me, EventArgs.Empty)

        AlertBox.Show("SelectionSort completed in " + stopwatch.ElapsedMilliseconds + " millisecods.")

        Me.sorted = True
        Me.buttonSort.Enabled = True
        Me.buttonSort.Text = "SORT"
        MainFormLbl.Text = i
        Application.Update()
    End Sub

    Private Sub RunQuickSort()
        Dim stopwatch As New Stopwatch()
        Me.buttonSort.Enabled = False
        Me.buttonSort.Text = "Sorting..."

        stopwatch.Start()
        DoQuickSort(0, values.Length - 1)
        MainFormLbl.Text = "quicksort"
        stopwatch.[Stop]()

        RaiseEvent SortCompleted(Me, EventArgs.Empty)

        AlertBox.Show("QuickSort completed in " + stopwatch.ElapsedMilliseconds + " millisecods.")

        Me.sorted = True
        Me.buttonSort.Enabled = True
        Me.buttonSort.Text = "SORT"
        Application.Update()
    End Sub

    Private Sub DoQuickSort(low As Integer, high As Integer)
        Dim lo = low
        Dim hi = high
        Dim mid = values((lo + hi) / 2)
        While True
            While values(lo) < mid
                lo = lo + 1
            End While
            While values(hi) > mid
                hi = hi - 1
            End While
            If lo <= hi Then
                SwapValue(lo, hi)
                lo = lo + 1
                hi = hi - 1
            End If
            If lo > hi Then
                Exit While
            End If
        End While
        If hi > low Then
            DoQuickSort(low, hi)
        End If
        If lo < high Then
            DoQuickSort(lo, high)
        End If
    End Sub

    Private Sub RunBubbleSort()
        Dim stopwatch As New Stopwatch()
        Me.buttonSort.Enabled = False
        Me.buttonSort.Text = "Sorting..."

        Dim i = 0
        Dim max = values.Length - 1
        stopwatch.Start()
        While i <= max
            Dim k = 0
            While k <= max - 1
                If values(k) > values(k + 1) Then
                    SwapValue(k, k + 1)
                End If
                k = k + 1
            End While
            i = i + 1
        End While
        stopwatch.[Stop]()

        RaiseEvent SortCompleted(Me, EventArgs.Empty)

        AlertBox.Show("BubbleSort completed in " & stopwatch.ElapsedMilliseconds & " millisecods.")

        Me.sorted = True
        Me.buttonSort.Enabled = True
        Me.buttonSort.Text = "SORT"
        Application.Update()
    End Sub

    Private Sub SwapValue(a As Integer, b As Integer)
        Dim t = values(a)
        values(a) = values(b)
        values(b) = t

        Dim thiscanvas = Me.Canvas1
        Dim rect = Me.DisplayRectangle
        thiscanvas.LiveUpdate = True
        Try
            ' clear the previous lines
            thiscanvas.BeginPath()
            thiscanvas.StrokeStyle = Me.BackColor
            thiscanvas.LineWidth = Me.lineWidth
            Dim y = a * (Me.lineWidth + Me.gap) + 1
            thiscanvas.MoveTo(0, y)
            thiscanvas.LineTo(rect.Width, y)
            y = b * (Me.lineWidth + Me.gap) + 1
            thiscanvas.MoveTo(0, y)
            thiscanvas.LineTo(rect.Width, y)
            thiscanvas.Stroke()

            ' draw the swapped lines.
            thiscanvas.BeginPath()
            thiscanvas.StrokeStyle = Me.ForeColor
            y = a * (Me.lineWidth + Me.gap) + 1
            thiscanvas.MoveTo(0, y)
            thiscanvas.LineTo(values(a), y)
            y = b * (Me.lineWidth + Me.gap) + 1
            thiscanvas.MoveTo(0, y)
            thiscanvas.LineTo(values(b), y)
            thiscanvas.Stroke()
            MainFormLbl.Text = y
        Finally
            thiscanvas.LiveUpdate = False
        End Try

        Application.Update()
        Thread.Sleep(Me.Delay)
    End Sub

    Public Property TitleText() As String
        Get
            Return TitleLbl.Text
        End Get
        Set(value As String)
            TitleLbl.Text = value
        End Set
    End Property

    Public Property SortMode() As SortMode
        Get
            Return m_SortMode
        End Get
        Set(value As SortMode)
            m_SortMode = value
        End Set
    End Property
    Private m_SortMode As SortMode

    Public Property Delay() As Integer
        Get
            Return m_Delay
        End Get
        Set(value As Integer)
            m_Delay = value
        End Set
    End Property
    Private m_Delay As Integer

    Protected Overrides Sub OnLoad(e As EventArgs)
        MyBase.OnLoad(e)
        Me.Delay = 10
        GenerateLines()
    End Sub


    Private Sub GenerateLines()
        Dim rand As New Random()

        Me.values = New Integer(Canvas1.Height / (Me.lineWidth + Me.gap) - 1) {}
        Dim i As Integer = 0, length As Integer = values.Length
        While i < length
            values(i) = rand.[Next](Me.Width)
            i += 1
        End While
    End Sub

    Private Sub DrawLines()
        Dim thiscanvas = Me.Canvas1
        Dim rect = Me.DisplayRectangle

        ' clear the canvas.
        thiscanvas.BeginPath()
        thiscanvas.ClearRect(rect)

        ' set the line color.
        thiscanvas.StrokeStyle = Me.ForeColor

        ' calculate the size if the line of the line.
        thiscanvas.LineWidth = Me.lineWidth

        Dim pos As Point = InlineAssignHelper(pos, New Point(0, 1))
        Dim i As Integer = 0, length As Integer = values.Length
        While i < length
            thiscanvas.MoveTo(pos)
            thiscanvas.LineTo(values(i), pos.Y)
            pos.Y += thiscanvas.LineWidth + gap
            i += 1
        End While

        thiscanvas.Stroke()
    End Sub

    Private Sub canvas_Redraw(sender As Object, e As EventArgs)
        DrawLines()
    End Sub
    Private Shared Function InlineAssignHelper(Of T)(ByRef target As T, value As T) As T
        target = value
        Return value
    End Function




End Class

Public Enum SortMode
    BubbleSort
    SelectionSort
    QuickSort
End Enum




